
#ifndef __SYSTEM__H
#define __SYSTEM__H

typedef char TBoolean;
typedef TBoolean *PBoolean;
static const TBoolean False = 0;
static const TBoolean True = 1;

typedef int TInt;
typedef TInt *PInt;

typedef char TInteger8;
typedef TInteger8 *PInteger8;

typedef short TInteger16;
typedef TInteger16 *PInteger16;

typedef long TInteger32;
typedef TInteger32 *PInteger32;

typedef long long TInteger64;
typedef TInteger64 *PInteger64;

typedef long long TInteger;
typedef TInteger *PInteger;

typedef unsigned char TUnsignedInteger8;
typedef TUnsignedInteger8 *PUnsignedInteger8;

typedef unsigned short TUnsignedInteger16;
typedef TUnsignedInteger16 *PUnsignedInteger16;

typedef unsigned long TUnsignedInteger32;
typedef TUnsignedInteger32 *PUnsignedInteger32;

typedef unsigned long long TUnsignedInteger64;
typedef TUnsignedInteger64 *PUnsignedInteger64;

typedef unsigned long long TUnsignedInteger;
typedef TUnsignedInteger *PUnsignedInteger;

typedef unsigned char TChar;
typedef TChar *PChar;

typedef float TFloat32;
typedef TFloat32 *PFloat32;

typedef double TFloat64;
typedef TFloat64 *PFloat64;

typedef float TFloat;
typedef TFloat *PFloat;

typedef void *TPointer;
typedef TPointer *PPointer;

typedef char TBuffer;
typedef TBuffer *PBuffer;

#ifdef _PC_

typedef TInteger TKeyboardKey;
typedef TKeyboardKey *PKeyboardKey;
static const TKeyboardKey kkNone             =  -1;
static const TKeyboardKey kkA                =   0;
static const TKeyboardKey kkB                =   1;
static const TKeyboardKey kkC                =   2;
static const TKeyboardKey kkD                =   3;
static const TKeyboardKey kkE                =   4;
static const TKeyboardKey kkF                =   5;
static const TKeyboardKey kkG                =   6;
static const TKeyboardKey kkH                =   7;
static const TKeyboardKey kkI                =   8;
static const TKeyboardKey kkJ                =   9;
static const TKeyboardKey kkK                =  10;
static const TKeyboardKey kkL                =  11;
static const TKeyboardKey kkM                =  12;
static const TKeyboardKey kkN                =  13;
static const TKeyboardKey kkO                =  14;
static const TKeyboardKey kkP                =  15;
static const TKeyboardKey kkQ                =  16;
static const TKeyboardKey kkR                =  17;
static const TKeyboardKey kkS                =  18;
static const TKeyboardKey kkT                =  19;
static const TKeyboardKey kkU                =  20;
static const TKeyboardKey kkV                =  21;
static const TKeyboardKey kkW                =  22;
static const TKeyboardKey kkX                =  23;
static const TKeyboardKey kkY                =  24;
static const TKeyboardKey kkZ                =  25;
static const TKeyboardKey kkAA               =  26;
static const TKeyboardKey kkBB               =  27;
static const TKeyboardKey kkCC               =  28;
static const TKeyboardKey kkDD               =  29;
static const TKeyboardKey kkEE               =  30;
static const TKeyboardKey kkFF               =  31;
static const TKeyboardKey kkGG               =  32;
static const TKeyboardKey kkHH               =  33;
static const TKeyboardKey kkII               =  34;
static const TKeyboardKey kkJJ               =  35;
static const TKeyboardKey kkKK               =  36;
static const TKeyboardKey kkLL               =  37;
static const TKeyboardKey kkMM               =  38;
static const TKeyboardKey kkNN               =  39;
static const TKeyboardKey kkOO               =  40;
static const TKeyboardKey kkPP               =  41;
static const TKeyboardKey kkQQ               =  42;
static const TKeyboardKey kkRR               =  43;
static const TKeyboardKey kkSS               =  44;
static const TKeyboardKey kkTT               =  45;
static const TKeyboardKey kkUU               =  46;
static const TKeyboardKey kkVV               =  47;
static const TKeyboardKey kkWW               =  48;
static const TKeyboardKey kkXX               =  49;
static const TKeyboardKey kkYY               =  50;
static const TKeyboardKey kkZZ               =  51;
static const TKeyboardKey kk0                =  52;
static const TKeyboardKey kk1                =  53;
static const TKeyboardKey kk2                =  54;
static const TKeyboardKey kk3                =  55;
static const TKeyboardKey kk4                =  56;
static const TKeyboardKey kk5                =  57;
static const TKeyboardKey kk6                =  58;
static const TKeyboardKey kk7                =  59;
static const TKeyboardKey kk8                =  60;
static const TKeyboardKey kk9                =  61;
static const TKeyboardKey kkRightParantheses =  62;
static const TKeyboardKey kkExclamation      =  63;
static const TKeyboardKey kkAt               =  64;
static const TKeyboardKey kkHash             =  65;
static const TKeyboardKey kkDollar           =  66;
static const TKeyboardKey kkProcent          =  67;
static const TKeyboardKey kkCaret            =  68;
static const TKeyboardKey kkAnd              =  69;
static const TKeyboardKey kkAsterisk         =  70;
static const TKeyboardKey kkLeftParantheses  =  71;
static const TKeyboardKey kkSpace            =  72;
static const TKeyboardKey kkTab              =  73;
static const TKeyboardKey kkBackSpace        =  74;
static const TKeyboardKey kkEnter            =  75;
static const TKeyboardKey kkComma            =  76;
static const TKeyboardKey kkPeriod           =  77;
static const TKeyboardKey kkLower            =  78;
static const TKeyboardKey kkBigger           =  79;
static const TKeyboardKey kkSlash            =  80;
static const TKeyboardKey kkQuestion         =  81;
static const TKeyboardKey kkBackslash        =  82;
static const TKeyboardKey kkPipe             =  83;
static const TKeyboardKey kkSemicolon        =  84;
static const TKeyboardKey kkColon            =  85;
static const TKeyboardKey kkApostrophe       =  86;
static const TKeyboardKey kkQuote            =  87;
static const TKeyboardKey kkLeftBracket      =  88;
static const TKeyboardKey kkLeftBrace        =  89;
static const TKeyboardKey kkRightBracket     =  90;
static const TKeyboardKey kkRightBrace       =  91;
static const TKeyboardKey kkMinus            =  92;
static const TKeyboardKey kkUnderScore       =  93;
static const TKeyboardKey kkPlus             =  94;
static const TKeyboardKey kkEqual            =  95;
static const TKeyboardKey kkPrime            =  96;
static const TKeyboardKey kkTilde            =  97;
static const TKeyboardKey kkEsc              =  98;
static const TKeyboardKey kkInsert           =  99;
static const TKeyboardKey kkDelete           = 100;
static const TKeyboardKey kkHome             = 101;
static const TKeyboardKey kkEnd              = 102;
static const TKeyboardKey kkPageUp           = 103;
static const TKeyboardKey kkPageDown         = 104;
static const TKeyboardKey kkUpArrow          = 105;
static const TKeyboardKey kkDownArrow        = 106;
static const TKeyboardKey kkLeftArrow        = 107;
static const TKeyboardKey kkRightArrow       = 108;

static const TInteger MaxKeyboardKeys = 109;

typedef TInteger TColor;
typedef TColor *PColor;
static const TColor ccBlack   = 0;
static const TColor ccRed     = 1;
static const TColor ccGreen   = 2;
static const TColor ccYellow  = 3;
static const TColor ccBlue    = 4;
static const TColor ccMagenta = 5;
static const TColor ccCyan    = 6;
static const TColor ccWhite   = 7;

struct TConsoleColor;
typedef struct TConsoleColor *PConsoleColor;
struct TConsoleColor
{
    TColor Foreground;
    TColor Background;
};

//Inchide fortat aplicatia, si afiseaza mesajul de eroare si linia la care s-a produs
void ForceClose(TInteger Line,PChar File,PChar Message);

#define DebugSystemAssert(Condition,Message) \
do\
  {\
   if ((Condition) == 0)\
     {\
      ForceClose(__LINE__,__FILE__,Message);\
     }\
  }\
 while (0)

#endif

//Genereaza un numar aleator
TInteger GenerateRandom(void);

#ifdef _PC_

//Aloca memoria
TPointer AllocateMemory(TInteger Size);
//Realoca memoria
TPointer ReAllocateMemory(TPointer P,TInteger Size);
//Elibereaza memoria
TPointer FreeMemory(TPointer P);
//Aloca si copiaza un buffer de string
PChar CopyPCharBuffer(PChar From);
//Aloca si copiaza un buffer de string de o anumita lungime
PChar CopyPCharBufferN(PChar From,TInteger Len);

#endif

//Seteaza pe zero un buffer
void ZeroMemoryBuffer(TPointer P,TInteger Size);
//Copiaza un buffer de memorie
void CopyMemoryBuffer(TPointer To,TPointer From,TInteger Len);

#ifdef _PC_

//Creaza consola
void CreateConsole(void);
//Distruge console
void DestroyConsole(void);
//Intoarce marimea consolei
void GetConsoleSize(TInteger *X,TInteger *Y);

//Modifica titlul consolei
void SetTitle(PChar Title);

//Pozitioneaza cursorul
void GoToPosition(TInteger X,TInteger Y);

//Seteaza culoarea care sa fie folosita
void SetColor(PConsoleColor Color);
//Construieste culoarea
void CreateColor(PConsoleColor C,TColor F,TColor B);

//Afiseaza un caracter
void WriteChar(TChar C);
//Afiseaza un string
void WriteString(PChar S);
//Afiseaza un string de o anumita lungime
void WriteStringN(PChar S,TInteger Len);
//Afiseaza un numar
void WriteInteger(TInteger N);

//Intoarce daca a fost apasata o tasta
TKeyboardKey GetKeyPressed(void);
//Intoarce codul ASCII al tastei, daca exista
TChar KeyToChar(TKeyboardKey KK);
//Intoarce tasta care a generat codul ASCII
TKeyboardKey CharToKey(TChar C);

//Curata outputul consolei
void ClearDisplay(TInteger MaxX,TInteger MaxY,PConsoleColor Color);
//Curata o parte din outputul consolei
void ClearWindow(TInteger X1,TInteger Y1,TInteger X2,TInteger Y2,PConsoleColor Color);
//Pune pe ecran outputul consolei
void UpdateDisplay(void);

#endif

//Pune firul de executie in asteptare un moment de timp
void WaitNanoSeconds(TInteger Nanoseconds);

struct TTimeMoment;
typedef struct TTimeMoment *PTimeMoment;
struct TTimeMoment
{
    TInteger16 Year;
    TInteger8 Month;
    TInteger8 Day;
    TInteger8 Hour;
    TInteger8 Minute;
    TInteger8 Second;
};

TInteger GetTimeFromMoment(PTimeMoment M);
void GetMomentFromTime(PTimeMoment M,TInteger T);

#ifdef _PC_

//Intoarce ceasul sistemului
TInteger GetTime(void);

#endif

//Copiaza un string
PChar StringCopy(PChar To,PChar From);
//Copiaza un string de o anumita lungime
PChar StringCopyN(PChar To,PChar From,TInteger Len);
//Concatenaza un string
PChar StringCat(PChar To,PChar From);
//Concateneaza un string de o anumita lungime
PChar StringCatN(PChar To,PChar From,TInteger Len);
//Compara doua stringuri
TInteger StringCmp(PChar S1,PChar S2);
//Compara doua stringuri de o anumita lungime maxima
TInteger StringCmpN(PChar S1,PChar S2,TInteger Len);
//Aloca memorie si intoarce un numar sub forma de string
//PChar IntToStr(TInteger T,PChar Dest);
//Intoarce lungimea stringului
TInteger StringLength(PChar S);
//Citeste un numar dintr-un string, daca este posibil
TBoolean StrToInt(PChar S,PInteger Out);

#ifdef _PC_

typedef TPointer TFile;
typedef TFile *PFile;

typedef TInteger TFileMode;
typedef TFileMode *PFileMode;
//Deschidere doar pentru citire
static const TFileMode fmOpenReadOnly = 0;
//Deschidere pentru scriere si citire
static const TFileMode fmOpenReadWrite = 1;
//Deschidere pentru scriere si citire, dar continutul fisierului este sters la deschidere
static const TFileMode fmOpenTruncate = 2;

//Deschide un fisier
TFile FileOpen(PChar FileName,TFileMode Mode);

//Ia pozitia din fisier a cursorului
TInteger FileGetPosition(TFile File);
//Seteaza pozitia in fisier a cursorului
TInteger FileSetPosition(TFile File,TInteger Position);

//Ia marimea fisierului
TInteger FileGetSize(TFile File);
//Seteaza marimea fisierului
TInteger FileSetSize(TFile File,TInteger Size);

//Citeste un buffer din fisier
TInteger FileRead(TFile File,TPointer Buffer,TInteger Size);
//Scrie un buffer in fisier
TInteger FileWrite(TFile File,TPointer Buffer,TInteger Size);
//Scrie fortat toate informatiile pe disk
void FileFlush(TFile File);

//Inchide fisierul
void FileClose(TFile File);

struct TWritingString;
typedef struct TWritingString *PWritingString;
struct TWritingString
{
    TInteger Len;
    TInteger BuffSize;
    TInteger MaxLen;
    PChar Data;
};

//Aloca si creaza un obiect folosit pentru input
PWritingString CreateEmptyWritingString(TInteger MaxLen);
//Adauga un caracter la final
void AppendCharToWritingString(PWritingString S,TChar C);
//Sterge ultimul caracter
void DeleteLastCharOfWritingString(PWritingString S);
//Aloca si creaza o copie a obiectului de input
void CopyWritingString(PWritingString To,PWritingString From);
//Elibereaza memoria folosita de obiectul de input
void DestroyWritingString(PWritingString S);

void InitNetworking(PChar DestinationIP,TInteger16 Port);
void SendPacket(PChar DestinationIP,TInteger16 Port,TPointer Data,TInteger Size);
void RecvPacket(PChar SourceIP,PInteger16 Port,TPointer Data,PInteger Size);
void CloseNetworking(void);

#endif

#endif
