
#ifndef UDP_PACKETS__H
#define UDP_PACKETS__H

#define PACKET_MAX_PACKET_SIZE 512
#define PACKET_CRYPT_BUFFER_SIZE 16
#define PACKET_MAX_AVAILABLE_SIZE (PACKET_MAX_PACKET_SIZE - (PACKET_MAX_PACKET_SIZE / PACKET_CRYPT_BUFFER_SIZE) * sizeof(TInteger8))

typedef TChar TPacketData;
typedef TPacketData *PPacketData;

struct TPacketWriter;
typedef struct TPacketWriter *PPacketWriter;
struct TPacketWriter
{
    TInteger16 Size;
    PPacketData Data;    
};

void PacketWriteStart(PPacketWriter Packet);
void PacketWriteFinish(PPacketWriter Packet,TInteger8 Marker);

TInteger16 PacketGetRemainingSize(PPacketWriter Packet);

TBoolean PacketWriteInteger8(PPacketWriter Packet,TInteger8 Value);
TBoolean PacketWriteInteger16(PPacketWriter Packet,TInteger16 Value);
TBoolean PacketWriteInteger32(PPacketWriter Packet,TInteger32 Value);
TBoolean PacketWriteInteger64(PPacketWriter Packet,TInteger64 Value);
TBoolean PacketWriteInteger(PPacketWriter Packet,TInteger Value);

TBoolean PacketWriteFloat32(PPacketWriter Packet,TFloat32 Value);
TBoolean PacketWriteFloat64(PPacketWriter Packet,TFloat64 Value);
TBoolean PacketWriteFloat(PPacketWriter Packet,TFloat Value);

TBoolean PacketWriteString(PPacketWriter Packet,PChar String);
TBoolean PacketWriteStringLen(PPacketWriter Packet,PChar String,TInteger16 Length);

TBoolean PacketWriteBuffer(PPacketWriter Packet,TPointer Buffer,TInteger16 Length);
TBoolean PacketWriteRawBuffer(PPacketWriter Packet,TPointer Buffer,TInteger16 Length);

struct TPacketReader;
typedef struct TPacketReader *PPacketReader;
struct TPacketReader
{
    TInteger16 Pos;
    TInteger16 Size;
    TInteger8 Marker;
    PPacketData Data;    
};

TBoolean PacketReadStart(PPacketReader Packet);
void PacketReadRestart(PPacketReader Packet);

TBoolean PacketReadInteger8(PPacketReader Packet,PInteger8 Value);
TBoolean PacketReadInteger16(PPacketReader Packet,PInteger16 Value);
TBoolean PacketReadInteger32(PPacketReader Packet,PInteger32 Value);
TBoolean PacketReadInteger64(PPacketReader Packet,PInteger64 Value);
TBoolean PacketReadInteger(PPacketReader Packet,PInteger Value);

TBoolean PacketReadFloat32(PPacketReader Packet,PFloat32 Value);
TBoolean PacketReadFloat64(PPacketReader Packet,PFloat64 Value);
TBoolean PacketReadFloat(PPacketReader Packet,PFloat Value);

TBoolean PacketReadString(PPacketReader Packet,PChar *String);
TBoolean PacketReadStringLen(PPacketReader Packet,PChar *String,PInteger16 Length);

TBoolean PacketReadBuffer(PPacketReader Packet,PPointer Buffer,PInteger16 Length);

TBoolean PacketReadRawBuffer(PPacketReader Packet,TPointer Buffer,TInteger16 Length);

#endif
