
#ifndef UDP_PROTOCOL__H
#define UDP_PROTOCOL__H

#define PacketOpcode_StatusInformation 1

#define PacketOpcode_SetTime 2
#define PacketOpcode_RequestStatus 3
#define PacketOpcode_StatusResponse 4

#define PacketOpcode_SetIrrigationTime 5
#define PacketOpcode_GetIrrigationPlan 6
#define PacketOpcode_DeleteIrrigationPlan 7

void WritePacket_StatusInformation(PPacketWriter Packet,TInteger8 Marker,PChar Info,TInteger Length);
void WritePacket_SetTime(PPacketWriter Packet,TInteger8 Marker,TInteger Time);
void WritePacket_RequestStatus(PPacketWriter Packet,TInteger8 Marker);
void WritePacket_StatusResponse(PPacketWriter Packet,TInteger8 Marker,TBoolean WaterSourceActive,TBoolean ValveOpen,
                                TInteger8 Sensors,TInteger MyTime,TInteger CurrentActionTime);
void WritePacket_SetIrrigationTime(PPacketWriter Packet,TInteger8 Marker,TInteger NewTime);
void WritePacket_GetIrrigationPlan(PPacketWriter Packet,TInteger8 Marker,TInteger Count,PInteger Plan);
void WritePacket_DeleteIrrigationPlan(PPacketWriter Packet,TInteger8 Marker,TInteger Time);

TBoolean VerifyPacketDevice(PPacketReader Reader);
TBoolean VerifyPacketProgram(PPacketReader Reader);
TBoolean VerifyPacket_StatusInformation(PPacketReader Reader);
TBoolean VerifyPacket_SetTime(PPacketReader Reader);
TBoolean VerifyPacket_RequestStatus(PPacketReader Reader);
TBoolean VerifyPacket_StatusResponse(PPacketReader Reader);
TBoolean VerifyPacket_SetIrrigationTime(PPacketReader Reader);
TBoolean VerifyPacket_GetIrrigationPlan(PPacketReader Reader);
TBoolean VerifyPacket_DeleteIrrigationPlan(PPacketReader Reader);

void ReadPacket_StatusInformation(PPacketReader Reader,PChar *Info,PInteger Length);
void ReadPacket_SetTime(PPacketReader Reader,PInteger Time);
void ReadPacket_RequestStatus(PPacketReader Reader);
void ReadPacket_StatusResponse(PPacketReader Reader,PBoolean WaterSourceActive,PBoolean ValveOpen,
                                PInteger8 Sensors,PInteger MyTime,PInteger CurrentActionTime);
void ReadPacket_SetIrrigationTime(PPacketReader Reader,PInteger NewTime);
void ReadPacket_GetIrrigationPlan(PPacketReader Reader,PInteger Count,PInteger Plan);
void ReadPacket_DeleteIrrigationPlan(PPacketReader Reader,PInteger Time);

/*void WritePacket_RequestStatus(PPacketWriter Packet,TInteger8 Marker);
void WritePacket_StatusResponse(PPacketWriter Packet,TInteger8 Marker,TInteger DeviceTime,TBoolean WaterSourceActive,
                                TBoolean ValveOpen,PBoolean SensorStatus);

void WritePacket_PrepareSendFile(PPacketWriter Packet,TInteger8 Marker,PChar Name,TInteger Size);
void WritePacket_PrepareSendFileReady(PPacketWriter Packet,TInteger8 Marker);

void WritePacket_RequestReceiveFile(PPacketWriter Packet,TInteger8 Marker,PChar Name,TInteger Size);
void WritePacket_RequestReceiveFileReady(PPacketWriter Packet,TInteger8 Marker);

void WritePacket_SendFileBuffer(PPacketWriter Packet,TInteger8 Marker,TPointer Data,TInteger Size);
void WritePacket_ReceivedFileBuffer(PPacketWriter Packet,TInteger8 Marker);*/

#endif
